#!/bin/sh

. /etc/PG.conf

CLOUD_CONF=${PGETC}/cloud.conf
	
[ -e ${CLOUD_CONF} ] && . ${CLOUD_CONF}

host=115.29.138.209

getblackip()
{
	cdir=`pwd`
	local host=$1

	# Download
	err=`fetch "http://${host}/newblackip.txt"`
	if [ -f ${cdir}/newblackip.txt ]; then
		# ʹһIPΪIP
		tbname="IP"

		# Ƿ
		err=`floweye table list | grep ${tbname}`
		if [ "${err}" = "" ]; then
			err=`floweye table add name=$tbname`
			tbid=`floweye table list | grep ${tbname} | cut -d' ' -f1`
			clear=0
		else
			clear=1
			tbid=`echo ${err} | cut -d' ' -f1`
		fi
	
		err=`floweye table loadfile tid=${tbid} file=${cdir}/newblackip.txt clear=${clear}`

		ugrpcnt=0
		result=`floweye policy listgrp`
		while read polid polname
		do
			[ "${polid}" = "" ] && continue
			ugrpcnt=$((${ugrpcnt}+1))
			err=`floweye policy addrule group=${polid} id=2 bridge=any dir=both app=any inip=any outip=${tbid} action=deny iprate=0 next=0 tos=0 pri=0 natip=0 hasms=0 qqcnt=0 vlan=0 desc=`
		done << EOF
			${result}
EOF
		[ "${ugrpcnt}" != "0" ] && return

		polname="ƽ̨ϲ"
		# ûвδбȵĲ飬򴴽
		err=`floweye policy addgrp ${polname}`
		polid=`floweye policy listgrp | grep ${polname} | cut -d' ' -f1`
		# 
		err=`floweye policy addrule group=${polid} id=2 bridge=any dir=both app=any inip=any outip=${tbid} action=deny iprate=0 next=0 tos=0 pri=0 natip=0 hasms=0 qqcnt=0 vlan=0 desc=`
		#豸ΪĬϵ
		err=`floweye policy setdefgrp ${polname}`
	fi
}

getblackdomain()
{
	cdir=`pwd`
	local host=$1

	# Download
	err=`fetch "http://${host}/blackdomain.txt"`
	if [ -f ${cdir}/blackdomain.txt ]; then
		# ʹһΪ
		tbname=""

		# Ƿ
		err=`floweye dns listgrp | grep ${tbname}`
		if [ "${err}" = "" ]; then
			err=`floweye dns addgrp $tbname`
			tbid=`floweye dns listgrp | grep ${tbname} | cut -d' ' -f2`
			clear=0
		else
			clear=1
			tbid=`echo ${err} | cut -d' ' -f2`
		fi
	
		err=`floweye dns loadfile ${tbid} ${cdir}/blackdomain.txt`
	
		# dnsܿز
		err=`floweye dns addrule id=1 inip=any outip=any dns=${tbid} inif=any bridge=0 action=deny ipqps=0 next= actarg=null`
	fi
}

if [ "${MT_BLACKIP}" = "1" ]; then
	getblackip "${host}"
	getblackdomain "${host}"
fi

while true
do
	hour=`date +%H`
	min=`date +%M`

	if [ "${MT_BLACKIP}" = "1" -a "${hour}" = "08" -a "${min}" = "00" ]; then
		getblackip ${host}
		getblackdomain ${host}
	fi

	sleep 60
done
